? src/xemacs.def.in.in
Index: Makefile.in.in
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/Makefile.in.in,v
retrieving revision 1.16
diff -d -u -r1.16 Makefile.in.in
--- Makefile.in.in	2003/05/02 06:00:41	1.16
+++ Makefile.in.in	2003/06/18 04:38:20
@@ -238,17 +238,22 @@
 ## instead, we have written out explicit code in the `install' targets.
 COPYDIR = ${srcdir}/etc ${srcdir}/lisp
 COPYDESTS = ${etcdir} ${lispdir}
-GENERATED_HEADERS = src/paths.h src/Emacs.ad.h src/config.h lwlib/config.h src/sheap-adjust.h
+GENERATED_HEADERS = src/paths.h src/Emacs.ad.h src/config.h lwlib/config.h src/sheap-adjust.h src/xemacs.def
+#ifdef HAVE_MS_WINDOWS
+MODULE_LIBS = src/xemacs-import.a src/xemacs-export.a
+#else
+MODULE_LIBS =
+#endif
 
 ## MAKE_SUBDIR will always be of the form lib-src ... src, where
 ## `...' includes various other directories that may be inserted by
 ## configure.
-all: Makefile ${GENERATED_HEADERS} ${MAKE_SUBDIR} info
+all: Makefile ${GENERATED_HEADERS} ${MODULE_LIBS} ${MAKE_SUBDIR} info
 
 ## For performance and consistency, no built-in rules
 .SUFFIXES:
 
-.NO_PARALLEL: ${GENERATED_HEADERS} ${MAKE_SUBDIR}
+.NO_PARALLEL: ${GENERATED_HEADERS} ${MODULE_LIBS} ${MAKE_SUBDIR}
 .PHONY: ${SUBDIR} all beta
 
 ## Convenience target for XEmacs beta testers
@@ -309,7 +314,7 @@
 FRC.src FRC.lib-src FRC.lwlib FRC.dynodump pkg-src/FRC.tree-x:
 FRC.lisp.finder-inf.el:
 
-${SUBDIR}: ${SUBDIR_MAKEFILES} ${GENERATED_HEADERS} FRC
+${SUBDIR}: ${SUBDIR_MAKEFILES} ${GENERATED_HEADERS} ${MODULE_LIBS} FRC
 	cd ./$@ && $(RECURSIVE_MAKE) all
 
 Makefile: ${srcdir}/Makefile.in.in config.status
@@ -336,6 +341,13 @@
 
 lwlib/config.h: ${srcdir}/lwlib/config.h.in
 	./config.status && touch $@
+
+src/xemacs.def: $(srcdir)/src/xemacs.def.in.in
+	./config.status && touch $@
+
+src/xemacs-export.a src/xemacs-import.a: src/xemacs.def
+	cd src && dlltool --input-def xemacs.def \
+	--output-exp xemacs-export.a --output-lib xemacs-import.a
 
 ## ==================== Installation ====================
 
Index: configure.in
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/configure.in,v
retrieving revision 1.202
diff -d -u -r1.202 configure.in
--- configure.in	2003/05/20 18:57:50	1.202
+++ configure.in	2003/06/18 04:38:44
@@ -5343,7 +5343,7 @@
   esac
   XE_APPEND($file, ac_output_files)
 done
-ac_output_files="$ac_output_files src/paths.h lib-src/config.values"
+ac_output_files="$ac_output_files src/paths.h src/xemacs.def.in lib-src/config.values"
 test "$with_modules" = "yes" && XE_APPEND(lib-src/ellcc.h, ac_output_files)
 
 AC_OUTPUT($ac_output_files,
@@ -5395,6 +5395,10 @@
 
     CPP_MAKEFILE(,Makefile)
     CPP_MAKEFILE(-DUSE_GNU_MAKE,GNUmakefile)
+    if test -e "xemacs.def.in"; then
+      cp -f xemacs.def.in junk.c
+      CPP_MAKEFILE(,xemacs.def)
+    fi
 changequote([,])dnl
     rm -f junk.c
   )
Index: modules/common/Makefile.common
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/modules/common/Makefile.common,v
retrieving revision 1.7
diff -d -u -r1.7 Makefile.common
--- modules/common/Makefile.common	2003/06/11 21:21:15	1.7
+++ modules/common/Makefile.common	2003/06/18 04:38:50
@@ -27,6 +27,9 @@
 
 ## Note: This will be appended to the individual module Makefiles by configure.
 
+#define NOT_C_CODE
+#include "../../src/config.h"
+
 SHELL=/bin/sh
 RM=rm -f
 PROGNAME=@PROGNAME@
@@ -54,6 +57,11 @@
 INSTALLPATH=@INSTALLPATH@
 INSTALL_PROGRAM=@MOD_INSTALL_PROGRAM@
 OBJECT_TO_BUILD=@OBJECT_TO_BUILD@
+#ifdef HAVE_MS_WINDOWS
+IMPORT_LIB=../../src/xemacs-import.a
+#else
+IMPORT_LIB=
+#endif
 
 .PHONY:	clean distclean install
 all: $(OBJECT_TO_BUILD)
@@ -63,7 +71,7 @@
 
 $(MODNAME).ell: $(OBJS) $(MODNAME)_i.o
 	$(MODCC) --mode=link --mode=verbose --mod-output=$@ \
-	$(OBJS) $(MODNAME)_i.o $(LDFLAGS)
+	$(OBJS) $(MODNAME)_i.o $(IMPORT_LIB) $(LDFLAGS)
 
 $(MODNAME)_i.c: $(SRCS)
 	ELLMAKEDOC=$(MAKE_DOCFILE) $(MODCC) --mode=init --mod-output=$@ \
Index: modules/ldap/eldap.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/modules/ldap/eldap.c,v
retrieving revision 1.5
diff -d -u -r1.5 eldap.c
--- modules/ldap/eldap.c	2003/02/07 20:46:02	1.5
+++ modules/ldap/eldap.c	2003/06/18 04:38:51
@@ -36,6 +36,9 @@
 #include "sysdep.h"
 #include "buffer.h"
 #include "process.h"		/* for report_process_error */
+#ifdef HAVE_SHLIB
+# include "emodules.h"
+#endif
 
 #include <errno.h>
 
Index: modules/postgresql/postgresql.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/modules/postgresql/postgresql.c,v
retrieving revision 1.3
diff -d -u -r1.3 postgresql.c
--- modules/postgresql/postgresql.c	2003/01/12 11:08:02	1.3
+++ modules/postgresql/postgresql.c	2003/06/18 04:38:54
@@ -102,6 +102,9 @@
 #include "buffer.h"
 #include "postgresql.h"
 #include "process.h"
+#ifdef HAVE_SHLIB
+# include "emodules.h"
+#endif
 
 #ifdef RUNNING_XEMACS_21_1 /* handle interface changes */
 #define PG_OS_CODING FORMAT_FILENAME
Index: src/Makefile.in.in
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/Makefile.in.in,v
retrieving revision 1.103
diff -d -u -r1.103 Makefile.in.in
--- src/Makefile.in.in	2003/04/10 08:46:24	1.103
+++ src/Makefile.in.in	2003/06/18 04:38:56
@@ -224,6 +224,9 @@
 
 #ifdef HAVE_SHLIB
 shlib_objs=sysdll.o emodules.o
+# ifdef HAVE_MS_WINDOWS
+shlib_objs+=xemacs-export.a
+# endif
 #endif
 
 #ifdef SUNPRO
